//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Misc. server commands avialable to clients
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

function serverCmdSAD( %client, %password )
{
   if( %password !$= "" && %password $= $Pref::Server::AdminPassword)
   {
      %client.isAdmin = true;
      %client.isSuperAdmin = true;
      %name = getTaggedString( %client.name );
      MessageAll( 'MsgAdminForce', "\c2" @ %name @ " has become Admin by force.", %client );   
   }
}

function serverCmdSADSetPassword(%client, %password)
{
   if(%client.isSuperAdmin)
      $Pref::Server::AdminPassword = %password;
}


//----------------------------------------------------------------------------
// Server chat message handlers

function serverCmdTeamMessageSent(%client, %text)
{
   if(strlen(%text) >= $Pref::Server::MaxChatLen)
      %text = getSubStr(%text, 0, $Pref::Server::MaxChatLen);
   chatMessageTeam(%client, %client.team, '\c3%1: %2', %client.name, %text);
}

function serverCmdMessageSent(%client, %text)
{
   if(strlen(%text) >= $Pref::Server::MaxChatLen)
      %text = getSubStr(%text, 0, $Pref::Server::MaxChatLen);
   chatMessageAll(%client, '\c4%1: %2', %client.name, %text);

   //----------------------------------------------------------------------------
   // COGMAC
   //----------------------------------------------------------------------------

   chatMessageAllOthers(%client, %text);
   ProcessChatMessage( %client, %text );

   //----------------------------------------------------------------------------
   // COGMAC
   //----------------------------------------------------------------------------
}

//----------------------------------------------------------------------------
// COGMAC
//----------------------------------------------------------------------------

function SetNarration(%sender, %msg)
{
   %count = ClientGroup.getCount();
   for ( %i = 0; %i < %count; %i++ )
   {
      %obj = ClientGroup.getObject( %i );

      // Don't send this to myself.
      if( %obj == %sender ) continue;	   
      commandToClient( %obj, 'SetNarration', %msg );
   }
}

function serverCmdToggleTypingIndicator(%sender, %val)
{
	%count = ClientGroup.getCount();
	for ( %i = 0; %i < %count; %i++ )
	{
	   %obj = ClientGroup.getObject( %i );

	   // Keep track of who is typing.
	   if( %obj == %sender ) %obj.isTyping = %val;
       %obj.hasListeners = true;

       // Don't send this to myself.
       if( %obj == %sender ) continue;	   
       commandToClient( %obj, 'ToggleTypingIndicator', %sender.player.getName(), %val );
	}

	// Start monitoring speakers if someone started typing.
	if( %val == true )
	{
		if( !$bMonitoringSpeakers )
		{
			$bMonitoringSpeakers = true;			
			schedule( 500, 0, MonitorSpeakers ); 
		}
	}
}

function MonitorSpeakers()
{
	// Determine if anyone is typing.
	%bIsTyping = false;
	%count = ClientGroup.getCount();
	for ( %i = 0; %i < %count; %i++ )
	{
	   %obj = ClientGroup.getObject( %i );

	   // Client is not typing.
	   if( !%obj.isTyping ) continue;

	   // Someone is typing.
	   %bIsTyping = true;

	   // Listening status has changed for this client.
	   %bHasListeners = HasListeners( %obj.player );
	   if( %obj.hasListeners != %bHasListeners )
	   {
	      %obj.hasListeners = %bHasListeners;
	      commandToClient( %obj, 'ToggleNoListenerWarning', %bHasListeners );
	   }
	}

	// Continue monitoring if someone is typing.
	if( %bIsTyping )
	{
		schedule( 500, 0, MonitorSpeakers ); 
	}

	// No one is typing anymore.
	else
	{
		//echo("==== DONE TYPING" );
		$bMonitoringSpeakers = false;			
	}
}

function HasListeners( %player )
{
   // Determine who the speaker is facing.
   for( %i=0; %i < $listenerList.nObjs; %i++ )
   {
      // Speaker cannot face himself!
      %obj = $listenerList.lstObjs[%i];
      if( %obj == %player ) continue;

      // Object is outside of the speaker's FOV.
      if( !%player.isInFOV( %obj, 180 ) ) continue;

      // Speaker is facing the object.
      return true;
   }

   // Speaker is not facing anyone.
   return false;
}



//----------------------------------------------------------------------------
// COGMAC
//----------------------------------------------------------------------------
















